<script>
import { mapState, mapGetters } from 'vuex';
import Inventory from './Inventory.vue';
import TextBox from './TextBox.vue';
import Hands from './Hands.vue';
import main from '~/lib/main';

export default {
  components: {
    Inventory,
    TextBox,
    Hands
  },
  mounted() {
    main(this);
  },
  computed: {
    ...mapState(['useGrayscaleCSS', 'lightsOn']),
    ...mapGetters(['enabledColors', 'hasNoColors']),
    mainClasses() {
      return {
        ...this.enabledColors,
        grayscale: this.useGrayscaleCSS && this.hasNoColors,
        'color-overlay': this.lightsOn
      };
    }
  }
};
</script>

<template>
  <div class="">
    <div class="main-container m-auto">
      <div class="relative" :class="mainClasses" ref="main"></div>
      <inventory />
      <text-box />
    </div>
    <hands />
  </div>
</template>

<style>
:root {
  --inventory-width: 160px;
  --canvas-width: 877;
  --canvas-height: 620;
}

.main-container {
  display: grid;
  width: calc(calc(1px * var(--canvas-width)) + var(--inventory-width));
  grid-template-columns: calc(1px * var(--canvas-width)) var(--inventory-width);
  grid-template-rows: calc(1px * var(--canvas-height)) auto;
}

.color-overlay::after {
  content: '';
  position: absolute;
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;
  pointer-events: none;
}

.color-overlay.grayscale canvas {
  filter: grayscale(1);
}

.color-overlay.blue::after {
  background-color: rgba(30, 30, 255, 0.5);
}

.color-overlay.blue.red::after {
  background-color: rgba(150, 30, 150, 0.5);
}

.color-overlay.blue.red.green::after {
  background: none;
}
</style>
